.globl _mapa

_pila1::
    .dw 0
_pila2::
    .dw 0
_pila3::
    .dw 0

_extractMap6x6::
    pop hl   ; dir de regreso
    ld (#_pila1), hl
    pop hl   ; hl = dir de matriz comprimida
    ld (#_pila2), hl
    pop bc   ; bc = tamComp
    ld (#_pila3), bc

    ld ix, #_mapa

    ; ix tiene la direccion del mapa a modificar
    ; hl = direccion de la matriz comprimida
    ; bc = tamaño de comprimido
    ; a = byte
    ; e = num de repeticiones
    ; d = tile


    ; primer byte
    inc bc
  principio:
    dec bc          ; decrementamos contador global
    ld a,#0
    or b
    or c
    jr z,fin       ; si hemos llegado a 0, finalizamos

    ld a, (hl)   ; leo comprimido[0]
    srl a
    srl a        ; byte >> 2
    ld e,a       ; num_rep = byte

    ld a,(hl)    ; leo comprimido[0]
    sla a
    sla a
    sla a
    sla a
    sla a
    sla a        ; byte << 6

    srl a
    srl a        ; byte >> 2
    ld d,a       ; tile = byte

    ; segundo byte
    inc hl
    ld a,(hl)    ; byte = comprimido[1]
    srl a
    srl a
    srl a
    srl a        ; byte >> 4
    or d         ; byte = byte OR tile
    ld d,a       ; tile = byte

    ; rellenamos con num_rep y tile
    ld a,#0            ; a = 0 # contador
  continuamos1:
    ld (ix),d          ; metemos en la pos ix+a el tile
    inc ix             ; incrementamos indice
    inc a              ; incrementamos contador
    cp e               ; contador < num_rep ?
    jr c,continuamos1  ; si es <, continuamos bucle

    dec bc          ; decrementamos contador global
    ld a,#0
    or b
    or c
    jr z,fin       ; si hemos llegado a 0, finalizamos

    ld a,(hl)      ; byte = comprimido[1]
    ld e,a         ; num_rep = byte
    sla e
    sla e
    sla e
    sla e          ; num_rep << 4
    srl e
    srl e          ; num_rep >> 2

    dec bc          ; decrementamos contador global
    ld a,#0
    or b
    or c
    jr z,fin       ; si hemos llegado a 0, finalizamos

    ; tercer byte   
    inc hl
    ld a,(hl)      ; byte = comprimido[2]
    srl a
    srl a
    srl a
    srl a
    srl a
    srl a          ; byte >> 6
    or e           ; byte = byte or num_rep
    ld e,a         ; num_rep = byte

    ld a,(hl)
    and #0b00111111 ; byte = byte AND 00111111
    ld d,a          ; tile = byte


    ; rellenamos con num_rep y tile
    ld a,#0            ; a = 0 # contador
   continuamos2:
    ld (ix),d          ; metemos en la pos ix+a el tile
    inc ix             ; incrementamos indice
    inc a              ; incrementamos contador
    cp e               ; contador < num_rep ?
    jr c,continuamos2  ; si es <, continuamos bucle


    inc hl
    jr principio       ; siempre bucle


  fin:
    ;ld sp, (#_pila)
    ld hl, (#_pila3)
    push hl
    ld hl, (#_pila2)
    push hl
    ld hl, (#_pila1)
    push hl

    ret
