//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of CPCtelera: An Amstrad CPC Game Engine
//  Copyright (C) 2015 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

#include <cpctelera.h>
#include "world.h"
#include "tninja.h"
#include "tprota.h"
#include "tenemy.h"
#include "tobjeto.h"

#include "tradworld.h"
#include "music/music.h"



/*************************************************************************************/
/*************************************************************************************/
/************************ NUEVO - Cofre | Llave | Puntuacion *************************/
/*************************************************************************************/
/*************************************************************************************/
Tobjecto cofre, llave, heart;

/**************** PUNTUACION ***********************/
u8 puntuacion;
u8 cofre_cogido;
u8 llave_cogida;
u8 start;
/*************************************************************************************/
/*************************************************************************************/
/*************************************************************************************/
/*************************************************************************************/


// Máscara de transparencia
cpctm_createTransparentMaskTable(g_tablatrans, 0x100, M0, 0);

TNinja prota;

extern void extractMap6x6(u8* comp, u16 tamComp);
extern void play();

u8 i;
void intHandler() {
    if (++i == 11) {
        /* cpct_akp_musicPlay(); */
        play();
        i=0;
    }
}

void textPressAnyKey(){
    u8 *pscr;
    pscr = cpct_getScreenPtr(screenMem, 10,  MAP_Y+60); 
    cpct_drawStringM0("Press any key to         start", pscr, COLOR_TEXTO, 1); 
    pscr = cpct_getScreenPtr(screenBuf, 10,  MAP_Y+60);  
    cpct_drawStringM0("Press any key to         start", pscr, COLOR_TEXTO, 1);  
}


void debug() {
    return;
}

// OJO cpct_drawCharM0 tiene que estar en pos de memoria > 4000 mirar el .map
void dibujarPuntuacion(u8 puntos) {
    u8 *pvmem;
    u8 unidades, decenas, centenas;

    centenas = puntos / 100;
    decenas  = (puntos % 100) / 10;
    unidades = puntos % 10;

    if(decenas == 0){
        pvmem = cpct_getScreenPtr(screenBuf, 44, MAP_Y-8);
        cpct_drawCharM0(pvmem, COLOR_TEXTO, 1, unidades+48); //48 = 0 en codigo ASCII
        pvmem = cpct_getScreenPtr(screenMem, 44, MAP_Y-8);
        cpct_drawCharM0(pvmem, COLOR_TEXTO, 1, unidades+48); //48 = 0 en codigo ASCII
    }

    if(unidades == 0){
        pvmem = cpct_getScreenPtr(screenBuf, 40, MAP_Y-8);
        cpct_drawCharM0(pvmem, COLOR_TEXTO, 1, decenas+48); 
        pvmem = cpct_getScreenPtr(screenMem, 40, MAP_Y-8);
        cpct_drawCharM0(pvmem, COLOR_TEXTO, 1, decenas+48); 
    }
    pvmem = cpct_getScreenPtr(screenBuf, 36, MAP_Y-8);
    cpct_drawCharM0(pvmem, COLOR_TEXTO, 1, centenas+48);
    pvmem = cpct_getScreenPtr(screenMem, 36, MAP_Y-8);
    cpct_drawCharM0(pvmem, COLOR_TEXTO, 1, centenas+48);

    //RECORDATORIO: Puntuacion solo llega hasta 255 porque puntuacion es u8
}

void dibujarVida() {
    // Dibujamos los corazones
    u8* pvmem;
    u8 j=NUM_VIDAS/2;
    do {
        --j;
        pvmem = cpct_getScreenPtr(screenMem, G_HEART_W*j +1, MAP_Y - G_HEART_H);
        cpct_drawSpriteMaskedAlignedTable(g_heart, pvmem, G_HEART_W, G_HEART_H, g_tablatrans);
        pvmem = cpct_getScreenPtr(screenBuf, G_HEART_W*j +1, MAP_Y - G_HEART_H);
        cpct_drawSpriteMaskedAlignedTable(g_heart, pvmem, G_HEART_W, G_HEART_H, g_tablatrans);
    } while(j);
}


void dibujarMapa() {
    // TODO mejorar dibujando solo uno y en la siguiente iteracion otro
    u8* pvmem;
    pvmem = cpct_getScreenPtr(screenMem, 0, MAP_Y);
    cpct_etm_drawTilemap2x4(MAP_W, MAP_H, pvmem, mapa);
    pvmem = cpct_getScreenPtr(screenBuf, 0, MAP_Y);
    cpct_etm_drawTilemap2x4(MAP_W, MAP_H, pvmem, mapa);
}

void calculaEnemigosMapa() {
    enemigos_mapa_ini = enemies_map[num_mapa*2];
    enemigos_mapa_num = enemies_map[num_mapa*2+1];
}

void avanzarMapa() {
   if (num_mapa < NUM_MAPAS-1) {
      ++num_mapa;
      calculaEnemigosMapa();

      extractMap6x6(mapas[num_mapa], tam_mapas[num_mapa]);
      dibujarMapa();
      prota.x[0] = 3;
   }
}

void retrocederMapa() {
   if (num_mapa > 0) {
      --num_mapa;
      calculaEnemigosMapa();

      extractMap6x6(mapas[num_mapa], tam_mapas[num_mapa]);
      dibujarMapa();
      prota.x[0] = MAX_X - 3;
   }
}

void ascenderMapa() {
   if (num_mapa >= 5) {
      --num_mapa;
      --num_mapa;
      --num_mapa;
      --num_mapa;
      --num_mapa;
      calculaEnemigosMapa();

      extractMap6x6(mapas[num_mapa], tam_mapas[num_mapa]);
      dibujarMapa();
      prota.y[0] = SUELO - (NINJA_H + 3);
   }
}

void descenderMapa() {
   if (num_mapa <= NUM_MAPAS-5-1) {
      ++num_mapa;
      ++num_mapa;
      ++num_mapa;
      ++num_mapa;
      ++num_mapa;
      calculaEnemigosMapa();

      extractMap6x6(mapas[num_mapa], tam_mapas[num_mapa]);
      dibujarMapa();
      prota.y[0] = TECHO + 3;
   }
}

void switchBuffers() {
    u8* aux = screenBuf;
    screenBuf = screenMem;
    screenMem = aux;

    cpct_setVideoMemoryPage( ((u16)screenMem >> 10) );
}



/////////////////////////////////// LLAVE
void estaLlave() {
    if(llave.visible){
        if(!llave_cogida){
            if((prota.x[0] >= llave.x && prota.x[0] <= llave.x + G_KEY_W) ||
            (prota.x[0] + NINJA_W >= llave.x && prota.x[0] + NINJA_W <= llave.x + G_KEY_W)) {
                if((prota.y[0] >= llave.y && prota.y[0] <= llave.y + G_KEY_H) ||
                (prota.y[0] + NINJA_H >= llave.y && prota.y[0] + NINJA_H <= llave.y + G_KEY_H)){
                    llave_cogida = 1;
                    borrarObjeto(&llave, mapa);
                }
            }
        }
    }
}
/////////////////////////////////// COFRE
void estaCofre() {
    if(cofre.visible){
        if(llave_cogida == 1 && !cofre_cogido){
            if((prota.x[0] >= cofre.x && prota.x[0] <= cofre.x + G_CHEST_W) || 
            (prota.x[0] + NINJA_W >= cofre.x && prota.x[0] + NINJA_W <= cofre.x + G_CHEST_W)) {
                if((prota.y[0] >= cofre.y && prota.y[0] <= cofre.y + G_CHEST_H) || 
                (prota.y[0] + NINJA_H >= cofre.y && prota.y[0] + NINJA_H <= cofre.y + G_CHEST_H)) {
                    cofre_cogido = 1;
                    dibujarPuntuacion(++puntuacion);
                    borrarObjeto(&cofre, mapa);

                    cofre_cogido = llave_cogida = 0;

                    posicionarObjeto(&cofre);
                    posicionarObjeto(&llave);

                    // Revivimos enemigos
                    enemyInicializar();
                }
            }
       }
    }
}

void jugar() {
    //Inicializar el mapa en el que vamos a empezar siempre
    num_mapa = 0;
    calculaEnemigosMapa();

    extractMap6x6(g_map1r, MAX_g_map1r);
    cpct_etm_setTileset2x4(g_tileset);
    dibujarMapa();

    prota.fAnimacion = fAnimProta;
    prota.x[0] = prota.x[1] = prota.x[2] = 40;
    prota.y[0] = prota.y[1] = prota.y[2] = 108;
    prota.mover = SI;  // Se inicia a 2 con SI
    prota.mira = MiraDer;
    prota.frame = prota.fAnimacion;  // Frame andar es el 0
    prota.estado = EstaAndando;
    prota.ciclo = 0;
    prota.visto = 0;
    prota.t = 0;
    prota.vidas = NUM_VIDAS;


    enemyInicializar();


    //Para probar... posicion de la caja y la llave
    posicionarObjeto(&cofre);
    posicionarObjeto(&llave);
    cofre.x = 27;
    cofre.y = 104-G_CHEST_H;
    llave.x = 30;
    llave.y = 104-G_KEY_H;

    heart.x = 5;
    heart.y = 55;
    heart.sala = num_mapa;

    puntuacion = 0;
    dibujarPuntuacion(puntuacion);
    dibujarVida();

}

void inicializar(){
    cpct_disableFirmware();
    cpct_setPalette(g_palette, 16);
    cpct_setBorder(HW_BLACK);
    cpct_setVideoMode(0);

    // TODO: quitamos música, ralentiza
    cpct_akp_musicInit(m_tradm);
    cpct_setInterruptHandler(intHandler);
}

void pressStart(){
    cpct_scanKeyboard();
    if(cpct_isAnyKeyPressed()){
        start = 2;
        jugar(); //EMPEZAR A JUGAR
    }
}

/************************************************************************************/
/************************************************************************************/
/************************************************************************************/
/************************************** MAIN ****************************************/
/************************************************************************************/
/************************************************************************************/
/************************************************************************************/
int main(void) {
    TNinja* penemigos;
    u8 dibujar;
    u8* pscr; // Pointer to the screen location where we want to draw


    cpct_setStackLocation((void*)0x7AAA);
    inicializar();


    // Pintamos
    cpct_memset(screenMem, cpct_px2byteM0(1, 1), 0x4000);
    cpct_drawSpriteMaskedAlignedTable(g_tradworld, screenMem, G_TRADWORLD_W, G_TRADWORLD_H, g_tablatrans);
    // Copiamos en buffer
    cpct_memcpy(screenBuf, screenMem, 0x4000);



    start = 0;

    //Dibujar 
    pscr = cpct_getScreenPtr(screenMem, 0,  MAP_Y+10); 
    cpct_drawStringM0("Welcome to Tradworld   Are you ready?", pscr, COLOR_TEXTO, 1); 
    pscr = cpct_getScreenPtr(screenBuf, 0,  MAP_Y+10);  
    cpct_drawStringM0("Welcome to Tradworld   Are you ready?", pscr, COLOR_TEXTO, 1);

    textPressAnyKey();

    // Loop forever
    while (1) {
        // Lecturas de teclado

        if(start == 0){ //MENU
            //Tocar cualquier tecla para empezar
            pressStart();
        }else if (start == 1){ //MUERTO - REINICIAR
            //Tocar cualquier tecla para empezar
            pressStart();
        }else{
            // Limpiamos teclado
            teclado = 0;

            // MOVIMIENTO DE ENEMIGO si VISTO o NO VISTO
            penemigos = enemies+enemigos_mapa_ini;


            if(penemigos->visto)
                modoVisto(penemigos, &prota);
            else
                modoPatrulla(penemigos, &prota);
            if(penemigos->estado != EstaAgachado)
                enemyActualizarEstado(penemigos);

            protaMatarEnemigo(&prota, penemigos);

            // Lecturas de teclado
            teclado = 0;
            cpct_scanKeyboard_if();
            if(cpct_isAnyKeyPressed()) {
                if (cpct_isKeyPressed(Key_CursorLeft))
                    teclado = teclado | K_LEFT;
                if (cpct_isKeyPressed(Key_CursorRight))
                    teclado = teclado | K_RIGHT;
                if (cpct_isKeyPressed(Key_CursorUp))
                    teclado = teclado | K_UP;
                if (cpct_isKeyPressed(Key_CursorDown))
                    teclado = teclado | K_DOWN;
                if (cpct_isKeyPressed(Key_Space))
                    teclado = teclado | K_SPACE;
            }
            ninjaActualizarEstado(&prota);


            dibujar = (penemigos->mover || prota.mover);

            if (prota.mover) { 
                ninjaActualizarFrame(&prota);

                if(prota.x[0] > MAX_X-1)
                    avanzarMapa();
                if(prota.x[0] < 1)
                    retrocederMapa();
                if(prota.y[0] < TECHO+1)
                    ascenderMapa();
                if(prota.y[0] > SUELO - (NINJA_H + 1))
                    descenderMapa();
                penemigos = enemies+enemigos_mapa_ini;  // Por si hemos movido mapa
                objetoVisible(&cofre);
                objetoVisible(&llave);
            }

            if (penemigos->mover)
                ninjaActualizarFrame(penemigos);

            if (dibujar) {
                /****************** Coger objetos *******************/  
                estaLlave();
                estaCofre();
                /****************************************************/
                // Dibujamos siempre aunque no se mueva para que un personaje no borre a otro
                if(prota.mover) ninjaBorrar(&prota, mapa);

                if(penemigos->mover) ninjaBorrar(penemigos, mapa);
                ninjaDibujar(penemigos, g_tablatrans);


                // Dibujar no pregunto, porque uno puede borrar a otro
                ninjaDibujar(&prota, g_tablatrans);

                if (!cofre_cogido && cofre.visible)
                   dibujarCofre(&cofre, g_tablatrans);

                if (!llave_cogida && llave.visible)
                   dibujarLlave(&llave, g_tablatrans);
            }

            //SI HE MUERTO
            if(prota.vidas==0){
                // Borro pantalla
                pscr = cpct_getScreenPtr(screenBuf, 0, MAP_Y);
                cpct_drawSolidBox(pscr, cpct_px2byteM0(1,1), 40, 200-MAP_Y);
                pscr = cpct_getScreenPtr(screenBuf, 40, MAP_Y);
                cpct_drawSolidBox(pscr, cpct_px2byteM0(1,1), 40, 200-MAP_Y);

                pscr = cpct_getScreenPtr(screenMem, 0, MAP_Y);
                cpct_drawSolidBox(pscr, cpct_px2byteM0(1,1), 40, 200-MAP_Y);
                pscr = cpct_getScreenPtr(screenMem, 40, MAP_Y);
                cpct_drawSolidBox(pscr, cpct_px2byteM0(1,1), 40, 200-MAP_Y);

                dibujarPuntuacion(puntuacion);
                start = 1;

                //Dibujar 
                pscr = cpct_getScreenPtr(screenBuf, 20, MAP_Y);
                cpct_drawStringM0("Final Score", pscr, COLOR_TEXTO, 1); 
                pscr = cpct_getScreenPtr(screenMem, 20, MAP_Y);
                cpct_drawStringM0("Final Score", pscr, COLOR_TEXTO, 1);

                textPressAnyKey();

            }
        }
        cpct_waitVSYNC();
        switchBuffers();
    } // while(1)
}

