#include "tenemy.h"

const u8 rangoDistY = 30; //en pixels
u8 distY;

const TFrame fAnimEnemy[NUM_FRAMES_ANIMACION] = {
    // Andar
    { MiraDer, g_enemy_00 },  // 0
    { MiraDer, g_enemy_01 }, 
    { MiraDer, g_enemy_02 }, 
    { MiraDer, g_enemy_03 },
    { MiraDer, g_enemy_04 },

    // Saltar
    { MiraDer, g_enemy_11 },  // 5
    { MiraDer, g_enemy_12 },
    { MiraDer, g_enemy_13 },

    // Aterrizar
    { MiraDer, g_enemy_14 },  // 8
    { MiraDer, g_enemy_15 },
    { MiraDer, g_enemy_16 },   // El ultimo de aterrizar es el personaje parado

    // Agarrar
    { MiraDer, g_enemy_18 },  // 11
    { MiraDer, g_enemy_17 },
    { MiraDer, g_enemy_05 },

    // comun a Agarrar y escalar
    { MiraDer, g_enemy_06 },  // 14

    // Escalar
    { MiraDer, g_enemy_07 },

    // Preparando Ataque
    { MiraDer, g_enemy_19 },  // 16
    { MiraDer, g_enemy_08 },

    // Atacar
    { MiraDer, g_enemy_20 },  // 18
    { MiraDer, g_enemy_09 },

    // Cayendo
    { MiraDer, g_enemy_13 },  // 20

    // comun a Agachado  y Preparando Atacando Agachado
    { MiraDer, g_enemy_21 },  // 21

    // Preparando Ataque Agachado
    { MiraDer, g_enemy_23 },  // 22

    // Atacando Agachado
    { MiraDer, g_enemy_22 },  // 23
    { MiraDer, g_enemy_10 }
};


TNinja enemies[
    MAP_ENEMY_00_NUM+
    MAP_ENEMY_01_NUM+
    MAP_ENEMY_02_NUM+
    MAP_ENEMY_03_NUM+
    MAP_ENEMY_04_NUM+
    MAP_ENEMY_05_NUM+
    MAP_ENEMY_06_NUM+
    MAP_ENEMY_07_NUM+
    MAP_ENEMY_08_NUM+
    MAP_ENEMY_09_NUM+
    MAP_ENEMY_10_NUM+
    MAP_ENEMY_11_NUM+
    MAP_ENEMY_12_NUM+
    MAP_ENEMY_13_NUM+
    MAP_ENEMY_14_NUM+
    MAP_ENEMY_15_NUM+
    MAP_ENEMY_16_NUM+
    MAP_ENEMY_17_NUM+
    MAP_ENEMY_18_NUM+
    MAP_ENEMY_19_NUM+
    MAP_ENEMY_20_NUM+
    MAP_ENEMY_21_NUM+
    MAP_ENEMY_22_NUM+
    MAP_ENEMY_23_NUM+
    MAP_ENEMY_24_NUM+
    MAP_ENEMY_25_NUM+
    MAP_ENEMY_26_NUM+
    MAP_ENEMY_27_NUM+
    MAP_ENEMY_28_NUM+
    MAP_ENEMY_29_NUM
    ];

void ini_enemies_map() __naked {
    __asm
        _enemies_map::
            .db MAP_ENEMY_00_INI, MAP_ENEMY_00_NUM
            .db MAP_ENEMY_01_INI, MAP_ENEMY_01_NUM
            .db MAP_ENEMY_02_INI, MAP_ENEMY_02_NUM
            .db MAP_ENEMY_03_INI, MAP_ENEMY_03_NUM
            .db MAP_ENEMY_04_INI, MAP_ENEMY_04_NUM
            .db MAP_ENEMY_05_INI, MAP_ENEMY_05_NUM
            .db MAP_ENEMY_06_INI, MAP_ENEMY_06_NUM
            .db MAP_ENEMY_07_INI, MAP_ENEMY_07_NUM
            .db MAP_ENEMY_08_INI, MAP_ENEMY_08_NUM
            .db MAP_ENEMY_09_INI, MAP_ENEMY_09_NUM
            .db MAP_ENEMY_10_INI, MAP_ENEMY_10_NUM
            .db MAP_ENEMY_11_INI, MAP_ENEMY_11_NUM
            .db MAP_ENEMY_12_INI, MAP_ENEMY_12_NUM
            .db MAP_ENEMY_13_INI, MAP_ENEMY_13_NUM
            .db MAP_ENEMY_14_INI, MAP_ENEMY_14_NUM
            .db MAP_ENEMY_15_INI, MAP_ENEMY_15_NUM
            .db MAP_ENEMY_16_INI, MAP_ENEMY_16_NUM
            .db MAP_ENEMY_17_INI, MAP_ENEMY_17_NUM
            .db MAP_ENEMY_18_INI, MAP_ENEMY_18_NUM
            .db MAP_ENEMY_19_INI, MAP_ENEMY_19_NUM
            .db MAP_ENEMY_20_INI, MAP_ENEMY_20_NUM
            .db MAP_ENEMY_21_INI, MAP_ENEMY_21_NUM
            .db MAP_ENEMY_22_INI, MAP_ENEMY_22_NUM
            .db MAP_ENEMY_23_INI, MAP_ENEMY_23_NUM
            .db MAP_ENEMY_24_INI, MAP_ENEMY_24_NUM
            .db MAP_ENEMY_25_INI, MAP_ENEMY_25_NUM
            .db MAP_ENEMY_26_INI, MAP_ENEMY_26_NUM
            .db MAP_ENEMY_27_INI, MAP_ENEMY_27_NUM
            .db MAP_ENEMY_28_INI, MAP_ENEMY_28_NUM
            .db MAP_ENEMY_29_INI, MAP_ENEMY_29_NUM
    __endasm;
}


void enemyActualizarEstado(TNinja* ninja) {
    switch  (ninja->estado) {
        case EstaParado: 
        case EstaAndando: 
            {
                ninjaMueveLateral(ninja);

                // Aun estando avanzando puede saltar
                if (teclado & K_LEFT || teclado & K_RIGHT) {
                    if (ninja->estado == EstaParado) {
                        ninja->estado = EstaAndando;
                    }
                } else {
                    if (ninja->estado == EstaAndando) {
                        ninja->estado = EstaParado;
                        ninja->mover = SI;
                    }
                }

                if (teclado & K_SPACE)
                    ninjaAnimar(ninja, EstaPreAtacando, ninja->fAnimacion+FRAME_INI_PREATACAR);
                break;
            }
        case EstaPreAtacando:          { ninja->mover = SI; break; }
        case EstaAtacando:             { ninja->mover = SI; break; }
        case EstaPosAtacando:          { ninja->mover = SI; break; }
    }
}

void enemyAtacar(TNinja* enemy, TNinja* prota) {
    // Si llegamos aqui, esque está cerca, tanto
    // en eje x como en y

    teclado = teclado | K_SPACE;


    // 1a iteracion: solo ataco normal

    // Si estamos atacando, como el personaje está cerca
    // significa que le estamos quitando vidas, pero solo
    // cuando pasa de estado EstaPreAtacando a EstaAtacando
    // es decir, cuando es el primer ciclo
    if (enemy->estado == EstaAtacando && enemy->ciclo == 0){
        // Controlo si está agachado no le hago daño
        if (prota->estado != EstaAgachado) {
            --prota->vidas;
            protaQuitarVida(prota->vidas);
        }
    }
}

void enemyUpOrSpace(TNinja* enemy, TNinja* prota) {
    u8* tile;
    u8 ex = enemy->x[0];
    u8 ey = enemy->y[0];
    u8 py = prota->y[0];

    // Si el prota esta por arriba, saltamos, sino, atacamos
    if (ey-(CICLOS_SALTAR*2) > py) {
        // solo saltamos si podemos llegar a una plataforma
        tile = obtenerTilePtr(ex + NINJA_W/2, ey-5);
        if(*tile == colD) {
            teclado = teclado | K_UP;
        }
        else {
            tile = obtenerTilePtr(ex + NINJA_W/2, ey-1);
            if(*tile == colD)
                teclado = teclado | K_UP;
            else {
                tile = obtenerTilePtr(ex + NINJA_W/2, ey+1);
                if(*tile == colD)
                    teclado = teclado | K_UP;
            }
        }
    } else
        if (ey == py)
            enemyAtacar(enemy, prota);
}


void patrullaTanquilo(TNinja* enemy){
    if(enemy->estado == EstaAgachado)
        return;

    if(enemy->t < 100) {
        ++enemy->t;
    }else{
        if(enemy->mira == MiraIzq)
            enemy->mira = MiraDer;
        else
            enemy->mira = MiraIzq;
        enemy->mover = SI;
        enemy->t = 0;
    } 
}

void patrullaOido(TNinja* enemy){
    u8* tile;

    if(enemy->estado == EstaAgachado)
        return;

    if(enemy->t < 100) {
        ++enemy->t;
    }else{
        //DERECHA
        if (enemy->mira == MiraDer) {
            //Que no se caiga
            tile = obtenerTilePtr(enemy->x[0]+NINJA_W+1 , enemy->y[0]+NINJA_H+1);
            if(*tile == colD){
                //Miro si puedo moverme
                tile = obtenerTilePtr(enemy->x[0] + NINJA_W, enemy->y[0]+NINJA_H-1);
                if(*tile != colR){
                    //Moverse
                    teclado = teclado | K_RIGHT;
                }else{
                    //Girarse y mirar
                    enemy->mira = MiraIzq;
                    enemy->t = 0;
                }
            }else{//HAY UN HUECO
                enemy->mira = MiraIzq;
                enemy->t = 0;
            }
        } else {
            tile = obtenerTilePtr(enemy->x[0] - 1, enemy->y[0]+NINJA_H+1);
            if(*tile == colD){
                tile = obtenerTilePtr(enemy->x[0] - 1, enemy->y[0]+NINJA_H-1);
                if(*tile != colL) {
                    teclado = teclado | K_LEFT;
                }else{
                    enemy->mira = MiraDer;
                    enemy->t = 0;
                }
            }else{//HAY UN HUECO
                enemy->mira = MiraDer;
                enemy->t = 0;
            }
        }

        enemy->mover = SI;
    }
}

void modoPatrulla(TNinja* enemy, TNinja* prota) {

    if(enemy->estado == EstaAgachado)
        return;

    //DETECTAR SI LO VE
    if(prota->y[0] == enemy->y[0]){
        //Si el protagonista está a la izquierda del enemigo
        if(prota->x[0] < enemy->x[0] && enemy->mira == MiraIzq) {
            enemy->visto = 1;
        }
        //Si el protagonista está a la derecha del enemigo
        if(prota->x[0] > enemy->x[0] && enemy->mira == MiraDer) {
            enemy->visto = 1;
        }

    }

    //DETECTA SI LO OYE (si salta cerca)
    distY = 0;
    if(prota->estado == EstaAterrizando){
        distY =  enemy->y - prota->y; //enemy debajo
        if(distY<rangoDistY){
            enemy->alterado = 1;   
        } 
    }

    //SI NO DETECTA NADA
    if(!enemy->visto){   
        switch (enemy->alterado) {
            case 0: patrullaTanquilo(enemy); break;
            case 1: patrullaOido(enemy); break;
            default: break;
        }
    }
}

void modoVisto(TNinja* enemy, TNinja* prota) {
    enemyCalculaIA(enemy, prota);
}



void enemyCalculaIA(TNinja* enemy, TNinja* prota) {
    u8* tile;

    if(enemy->estado == EstaAgachado)
        return;
    else {
            u8 ex = enemy->x[0];
            u8 ey = enemy->y[0];
            u8 px = prota->x[0];
            u8 py = prota->y[0];

    // 1a iteracion:
    // Busca posición en X y lo persique, cuando está cerca ataca
    // 2a iteración:
    // Si el prota está más alto, busca como subir
    // 3a iteración:
    // Si el prota está más bajo, buscar una bajada
    // 4a iteración:
    // Si el enemigo esta en la parte baja del mapa no se tirará abajo 

    // TODO Si el prota está por abajo, patrullamos hasta caer
 /*   if (enemy->y[0] + NINJA_H < prota->y[0]) {
        if (enemy->mira == MiraIzq) {
            // Va camino izquierda
            tile = obtenerTilePtr(enemy->x[0] - 1, enemy->y[0]+NINJA_H-1);
            if (*tile == colL) {
                // Cambiamos de dirección
                cpct_setBit(&teclado, 1, K_RIGHT);
            } else
                cpct_setBit(&teclado, 1, K_LEFT);
        } else {
            // Va camino derecha
            tile = obtenerTilePtr(enemy->x[0] + NINJA_W, enemy->y[0]+NINJA_H-1);
            if (*tile == colR) {
                // Cambiamos de dirección
                cpct_setBit(&teclado, 1, K_LEFT);
            } else
                cpct_setBit(&teclado, 1, K_RIGHT);
        }
    } else {*/
        // Miramos al prota
        if (ex > px) { // El prota está a la izquierda
            enemy->mira = MiraIzq;

            if ((ex - px) < NINJA_W){
                // Si esta cerca
                // Buscamos si esta mas alto, sino, atacamos
                enemyUpOrSpace(enemy, prota);
            } else {
                // Miro si puedo avanzar sin caerme
                tile = obtenerTilePtr(ex - 1, ey+NINJA_H+1);
                if(*tile == colD){
                    teclado = teclado | K_LEFT;
                }
            }
            enemy->mover = SI;

        } else { // El prota está a la derecha
            enemy->mira = MiraDer;

            if ((px - ex) < NINJA_W) {
                // Si esta cerca
                // Buscamos si esta mas alto, sino, atacamos
                enemyUpOrSpace(enemy, prota);
            } else {
                // Miro si puedo avanzar sin caerme
                tile = obtenerTilePtr(ex+NINJA_W+1 , ey+NINJA_H+1);
                if(*tile == colD){
                    teclado = teclado | K_RIGHT;
                }
            }
            enemy->mover = SI;
        }
    }
}

void enemyQuitarVida(TNinja* enemy) {
    --enemy->vidas;
    if (enemy->vidas==0) {
        enemy->estado = EstaAgachado;
        enemy->mover = SI;
    }
}

void enemyInicializar() {
    u8 j = NUM_MAPAS;
    TNinja* penemies = enemies;

    do{
        penemies->fAnimacion = fAnimEnemy;
        penemies->mover = SI;
        penemies->mira = MiraDer;
        penemies->frame = penemies->fAnimacion;
        penemies->visto = 0;
        penemies->alterado = 0;
        penemies->vidas = 2;
        penemies->t = 0;
        penemies->ciclo = 0;
        penemies->estado = EstaParado;
        penemies++;
    } while(--j);

    // 0
    penemies = enemies;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 8  * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] = 31 * 4 - NINJA_H + MAP_Y;

    // 1
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 23 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] =  9 * 4 - NINJA_H + MAP_Y;

    // 2
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 23 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] =  9 * 4 - NINJA_H + MAP_Y;

    // 3
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 19 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] = 31 * 4 - NINJA_H + MAP_Y;

    // 4
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 20 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] = 30 * 4 - NINJA_H + MAP_Y;

    // 5
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 20 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] =  9 * 4 - NINJA_H + MAP_Y;

    // 6
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 20 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] = 23 * 4 - NINJA_H + MAP_Y;

    // 7
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 13 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] = 9 * 4 - NINJA_H + MAP_Y;

    // 8
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 22 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] =  9 * 4 - NINJA_H + MAP_Y;

    // 9
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 24 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] = 23 * 4 - NINJA_H + MAP_Y;

    // 10
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 21 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] =  9 * 4 - NINJA_H + MAP_Y;

    // 11
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 9 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] = 9 * 4 - NINJA_H + MAP_Y;

    // 12
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 19 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] =  9 * 4 - NINJA_H + MAP_Y;

    // 13
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 26 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] = 23 * 4 - NINJA_H + MAP_Y;

    // 14
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 24 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] =  9 * 4 - NINJA_H + MAP_Y;

    // 15
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 26 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] = 23 * 4 - NINJA_H + MAP_Y;

    // 16
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 16 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] = 29 * 4 - NINJA_H + MAP_Y;

    // 17
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 21 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] =  9 * 4 - NINJA_H + MAP_Y;

    // 18
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 21 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] =  9 * 4 - NINJA_H + MAP_Y;

    // 19
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 20 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] = 17 * 4 - NINJA_H + MAP_Y;

    // 20
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 15 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] =  9 * 4 - NINJA_H + MAP_Y;

    // 21
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 23 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] = 31 * 4 - NINJA_H + MAP_Y;

    // 22
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 21 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] =  9 * 4 - NINJA_H + MAP_Y;

    // 23
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 25 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] = 21 * 4 - NINJA_H + MAP_Y;

    // 24
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 22 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] =  9 * 4 - NINJA_H + MAP_Y;

    // 25
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 12 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] = 31 * 4 - NINJA_H + MAP_Y;

    // 26
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 20 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] =  9 * 4 - NINJA_H + MAP_Y;

    // 27
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 21 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] = 24 * 4 - NINJA_H + MAP_Y;

    // 28
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 21 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] =  9 * 4 - NINJA_H + MAP_Y;

    // 29
    penemies++;
    penemies->x[0] = penemies->x[1] = penemies->x[2] = 25 * 2;
    penemies->y[0] = penemies->y[1] = penemies->y[2] = 14 * 4 - NINJA_H + MAP_Y;
}


/* void enemyVisible(TNinja* enemy) { */
/*    if(enemy->sala == num_mapa){ */
/*         enemy->visible = 1; */
/*     }else{ */
/*         enemy->visible = 0; */
/*     }  */
/* } */
