#ifndef _WORLD_H_
#define _WORLD_H_

#include <cpctelera.h>

#include "maps/map1r.h"
#include "maps/map2rl.h"
#include "maps/map3drl.h"

#include "maps/map1u.h"
#include "maps/map1d.h"
#include "maps/map1l.h"

#include "maps/map2ud.h"
#include "maps/map2ud_2.h"
#include "maps/map2ud_3.h"
#include "maps/map2ur.h"
#include "maps/map2ul.h"
#include "maps/map2ul_2.h"
#include "maps/map2dr.h"
#include "maps/map2dl.h"

#include "maps/map3url.h"
#include "maps/map3udr.h"
#include "maps/map3udl.h"
#include "maps/map3udl_2.h"


#include "maps/map4.h"
#include "maps/map4_2.h"

#include "sprites/castillo.h"
#include "sprites/ninja.h"


#define SI      2
#define NUM_VIDAS 6    // Las vidas tienen que ser pares

#define MAP_W   40
#define MAP_H   33

#define MAX_X        MAP_W*G_CASTILLO_00_W - G_NINJA_00_W
#define SUELO		 200
#define TECHO		 68
#define MAP_Y        68

#define K_LEFT   0b00000001
#define K_RIGHT  0b00000010
#define K_UP     0b00000100
#define K_DOWN   0b00001000
#define K_SPACE  0b00010000


#define colL 28
#define colR 42
#define colU 20
#define colD 16

#define COLOR_TEXTO 15


typedef struct {
    u8 mira;
    u8* sprite;
} TFrame;

extern enum {
    MiraIzq = 0,
    MiraDer
} EMirar;



extern u8 mapa[MAP_W*MAP_H];

extern u8 teclado;

/////////////////////////////

#define NUM_MAPAS 30
extern u8* const mapas[NUM_MAPAS];
extern u16 const tam_mapas[NUM_MAPAS];
extern u8 num_mapa;
extern u8 enemigos_mapa_num;
extern u8 enemigos_mapa_ini;

/////////////////////////////
extern u8* screenMem;
extern u8* screenBuf;



// Obtiene el num de tile de la posicion x e y
// en el mapa
u8* obtenerTilePtr(u8 x, u8 y);

#endif
